package entities;

import com.haxepunk.HXP;
import com.haxepunk.Entity;
import com.haxepunk.graphics.Image;
import com.haxepunk.graphics.Spritemap;

import haxe.Timer;

/**
 * ...
 * @author Andrew Shuan Dang
 */
class Ripple extends Entity
{
	private var sprite:Spritemap;
	
	public var gameLost:Bool = false;

	public function new(x:Int, y:Int)
	{
		super(x, y);
		
		//animated sprite
		sprite = new Spritemap("graphics/ripple.png", 96, 96);
		
        sprite.add("ripple", [0, 1, 2, 3, 4, 5, 6], 18, false);
        sprite.play("ripple");
		
		graphic = sprite;
		graphic.x = -45;
		graphic.y = -45;
	}
	
	public override function update()
	{	
		if (sprite.complete) {
			HXP.world.remove(this);
		}
		super.update();
		
		
	}
	
}